package info.extensiblecatalog.nacm.importer.test;

import info.extensiblecatalog.nacm.importer.FailedImportException;
import info.extensiblecatalog.nacm.importer.RecordImporter;
import info.extensiblecatalog.nacm.model.AuthorityRecord;
import info.extensiblecatalog.nacm.model.BibliographicRecord;
import info.extensiblecatalog.nacm.model.persistence.AuthorityRecordDAO;
import info.extensiblecatalog.nacm.model.persistence.BibliographicRecordDAO;
import info.extensiblecatalog.nacm.model.persistence.DataAccessException;

import java.io.File;

import junit.framework.TestCase;

public class RecordImporterTest extends TestCase {
	
	RecordImporter recordImporter;

	public void setUp() throws Exception {
		super.setUp();
		recordImporter = new RecordImporter();
	}
	
	public void testImportMarcAuthFile() throws DataAccessException {
		
		int numberOfEntries;
		Object returnedObject = null;
		
		AuthorityRecordDAO authDAO = new AuthorityRecordDAO();
		
		numberOfEntries = authDAO.findByAuthorizedName("Simpson, Carl").size();
		
		File testFile = new File("testdata/TestMarcAuth.xml");
		
		try {
			returnedObject = recordImporter.importRecord(testFile);
		} catch (DataAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FailedImportException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		assertEquals(authDAO.findByAuthorizedName("Simpson, Carl").size(), numberOfEntries + 1);
		
		authDAO.remove((AuthorityRecord) returnedObject);
		
	}
	
	public void testImportMarcBibFile() throws DataAccessException {
		
		int numberOfEntries;
		Object returnedObject = null;
		
		BibliographicRecordDAO bibDAO = new BibliographicRecordDAO();
		
		numberOfEntries = bibDAO.findByNormalizedAuthor("simpson, carl").size();
		
		File testFile = new File("testdata/TestMarcBib.xml");
		
		try {
			returnedObject = recordImporter.importRecord(testFile);
		} catch (DataAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FailedImportException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		assertEquals(bibDAO.findByNormalizedAuthor("simpson, carl").size(), numberOfEntries + 1);
		
		bibDAO.remove((BibliographicRecord) returnedObject);
		
	}
	
	public void testImportDCAuthFile() {
		
	}

}
