package info.extensiblecatalog.nacm.matcher;

import info.extensiblecatalog.nacm.model.BibliographicRecord;

/**
 * Provides callback methods to notify
 * callers of events during processing
 * 
 * @author Rob Busack
 */
public class ProgressCallback {
	
	/**
	 * Sets the total number of records to process
	 * @param length	the total number of records
	 */
	public void setLengthOfTask( int length )
	{
		// empty implementation
	}
	
	/**
	 * Sets the number of records processed so far
	 * @param progress	the number of records processed
	 */
	public void setProgress( int progress )
	{
		// empty implementation
	}
	
	/**
	 * Notifies caller that processing of a record failed
	 * @param record	the record that could not be matched
	 * @param reason	the reason it could not be matched
	 */
	public void itemFailed(BibliographicRecord record, Throwable reason)
	{
		// empty implementation
	}

}
