package info.extensiblecatalog.nacm.model.persistence;

import java.util.Date;

/**
 * @author Rob Busack
 * 
 * 
 */
public class Filter {

	/** number of columns in the results table */
	public static final int NUM_FIELDS = 8;
	
	// Indexes of columns in results table.
	// Changes to these values will change the order of the columns in the ResultsTable GUI.
	public static final int FLAGGED = 0;
	public static final int MARKED_AS = 1;
	public static final int BIB_NAME = 2;
	public static final int AUTH_NAME = 3;
	public static final int CONFIDENCE = 4;
	public static final int REASON = 5;
	public static final int DATE_CREATED = 6;
	public static final int MARKED_BY = 7;
	
	/** which column the results should be sorted by */
	private int sortBy = DATE_CREATED;	// sort by date by default
	
	private boolean showOnlyFlagged = false;
	
	private boolean showUnverified = true;
	private boolean showAccepted = true;
	private boolean showRejected = true;
	
	// ranges are expected to be inclusive of the max & min
	private double minConfidence = 0;
	private double maxConfidence = 100;
	
	private Date oldest;
	private Date newest;
	
	// generated getters and setters
	public Date getOldest() {
		return oldest;
	}
	public void setOldest(Date createdAfter) {
		this.oldest = createdAfter;
	}
	public Date getNewest() {
		return newest;
	}
	public void setNewest(Date createdBefore) {
		this.newest = createdBefore;
	}
	public double getMaxConfidence() {
		return maxConfidence;
	}
	public void setMaxConfidence(double maxConfidence) {
		this.maxConfidence = maxConfidence;
	}
	public double getMinConfidence() {
		return minConfidence;
	}
	public void setMinConfidence(double minConfidence) {
		this.minConfidence = minConfidence;
	}
	public boolean isShowAccepted() {
		return showAccepted;
	}
	public void setShowAccepted(boolean showAccepted) {
		this.showAccepted = showAccepted;
	}
	public boolean isShowOnlyFlagged() {
		return showOnlyFlagged;
	}
	public void setShowOnlyFlagged(boolean showOnlyFlagged) {
		this.showOnlyFlagged = showOnlyFlagged;
	}
	public boolean isShowRejected() {
		return showRejected;
	}
	public void setShowRejected(boolean showRejected) {
		this.showRejected = showRejected;
	}
	public boolean isShowUnverified() {
		return showUnverified;
	}
	public void setShowUnverified(boolean showUnverified) {
		this.showUnverified = showUnverified;
	}
	public int getSortBy() {
		return sortBy;
	}
	public void setSortBy(int sortBy) {
		this.sortBy = sortBy;
	}
	
}
