/**
 * 
 */
package info.extensiblecatalog.nacm.transformers;

/**
 * Performs a normalization of the givven string
 * 
 * @author Matthew Horoszowski
 */
public class StringNormalization extends StringTransformer {

	/* (non-Javadoc)
	 * @see info.extensiblecatalog.nacm.transformers.StringTransformer#transform(java.lang.String)
	 */
	@Override
	public String transform(String source) {

		//Normalization table transforms
		
		//Delete leading, trailing blanks
		source = source.trim();
		
		//Compress mutiple blanks
		while (source.contains("  ")) {
			source = source.replace("  ", " ");
		}
		
		//Convert all to lower case
		source = source.toLowerCase();
		
		//Delete diaritics
		
		
		//Translated characters
		
		
		//Punctuation
		
		//Blank ! "
		source = source.replace("!", " ");
		source = source.replace("\"", " ");
		
		//Delete '
		source = source.replace("'", "");
		
		//Blank ( ) -
		source = source.replace("(", " ");
		source = source.replace(")", " ");
		source = source.replace("-", " ");
		
		//Delete [ ]
		source = source.replace("[", "");
		source = source.replace("]", "");
		
		//Blank { } < > ; : . ?   
		source = source.replace("{", " ");
		source = source.replace("}", " ");
		source = source.replace("<", " ");
		source = source.replace(">", " ");
		source = source.replace(";", " ");
		source = source.replace(":", " ");
		source = source.replace(".", " ");
		source = source.replace("?", " ");
		source = source.replace("", " ");
		source = source.replace("", " ");

		//Blank , enless its the first in the field
		if (source.contains(",")) {
			source = source.substring(0,source.indexOf(",")+1) + 
					 source.substring(source.indexOf(",")+1,source.length()).replace(",", " ");
		}
		
		//Other numbers and special characters
		
		//Blank / \ @ *
		source = source.replace("/", " ");
		source = source.replace("\\", " ");
		source = source.replace("@", " ");
		source = source.replace("*", " ");
		
		//Delete |
		source = source.replace("|", "");
		
		//Blank % = $ ~
		source = source.replace("%", " ");
		source = source.replace("=", " ");
		source = source.replace("$", " ");
		source = source.replace("~", " ");
		
		return source;
		
	}

}
