package info.extensiblecatalog.nacm.transformers.test;

import info.extensiblecatalog.nacm.transformers.StringNormalization;
import junit.framework.TestCase;

public class StringNormalizationTest extends TestCase {
	
	StringNormalization normalizer;

	@Override
	protected void setUp() throws Exception {
		super.setUp();
		normalizer = new StringNormalization();
	}
	
	public void testBlanks() {
		
		String testString = "   testing   of      many things    ";
		assertEquals(normalizer.transform(testString), "testing of many things");
		
	}
	
	public void testCaseConversion() {
		
		String testString = "HelloHowAreYouToday";
		assertEquals(normalizer.transform(testString), "hellohowareyoutoday");
		
	}
	
	public void testPunctuation() {
		
		String testString = "hello!there\"how 'are(you)today-I[]{am}doing<just>fine;thank:you.for?askingmeabout it";
		assertEquals(normalizer.transform(testString), "hello there how are you today i am doing just fine thank you for asking me about it");
	
	}
	
	public void testCommas() {
		
		String testString = "hello, timmy, boy";
		assertEquals(normalizer.transform(testString), "hello, timmy  boy");
		
	}

	public void testSpecialCharacter() {
	
		String testString = "hello/there\\how@are*|you%doing=$today~sir";
		assertEquals(normalizer.transform(testString), "hello there how are you doing  today sir");
		
	}
	
}
